

/*
  Horloge parlante  avec CI DS3231, Afficheur 64*128 et module vocal utilisant une carte SD.

  Consultez impérativement le fichier "A lire.pdf" joint au dossier complet.
  -------------------------------------------------------------------------

  Adresses des fichiers wav.

  //PORTB = B00011110; //1          1
  //PORTB = B00011101; //2          2
  //PORTB = B00011100; //3          3
  //PORTB = B00011011; //4          4
  //PORTB = B00011010; //5          5
  //PORTB = B00011001; //6          6
  //PORTB = B00011000; //7          7
  //PORTB = B00010111; //8          8
  //PORTB = B00010110; //9          9
  //PORTB = B00010101; //10        10
  //PORTB = B00010100; //11        11
  //PORTB = B00010011; //12        12
  //PORTB = B00010010; //13        13
  //PORTB = B00010001; //14        14
  //PORTB = B00010000; //15        15
  //PORTB = B00001111; //16        16
  //PORTB = B00001110; //vingt     17
  //PORTB = B00001101; //trente    18
  //PORTB = B00001100; //quarante  19
  //PORTB = B00001011; //cinquante 20
  //PORTB = B00001010; //il est    21
  //PORTB = B00001001; //heure     22
  //PORTB = B00001001; //midi      23
  //PORTB = B00001000; //miuit     24
  //PORTB = B00000111; //minute    25  
  //PORTB = B00000101; //seconde   26
  //PORTB = B00000100; //té        27
  //PORTB = B00000011; //zero      28
  //PORTB = B00000010; //zheure    29
  //PORTB = B00000001; //theure    30

  Mon site http://f5mna .free.fr
  Dernière modif parole 12/04/16
  Avril 2016
*/

#include <U8glib.h>
#include <Wire.h>
#include <math.h>
#include <DS1307new.h>

U8GLIB_ST7920_128X64_1X u8g(6, 5, 4 , 7); // Pour ST7920 128*64
//Horloge
int angles, anglem, angleh, xs, ys, xm, ym, xh, yh;
float rad;

//DS3231 / DS3232
/*
  CI DS3232
  VDD  3VCC ou 5VCC
  SDA  A4
  SCL  A5
*/
//////////////////////////////////////////////////
int I2C_DS3232 = 0xD0 >> 1;
byte DS3232control = 0b00011100, DS3232status = 0b11001000 , DS3232aging , DS3232Msb , DS3232Lsb;
//////////////////////////////////////////////////
uint16_t startAddr = 0x0000;       // Adresse de démarrage Start dans  NV-RAM
uint16_t lastAddr;                 // Nelle addresse de stockage NV-RAM
uint16_t TimeIsSet = 0xaa55;       // Prévient qu'il n'y a pas de remise à l'heure
//


#define Touche_PIN  A0 // Entree platine 4 Boutons poussoirs
int sensorPin = A0;
int sensorValue = 0;
int val_key;
int Select;
int Heure;
int Minute;
int Seconde;
int Jour;
int Mois;
int Annee;
int JourSem;

void setup () {

  pinMode(2, INPUT);                    // Test  SQW pin, D2 = INPUT
  digitalWrite(2, HIGH);                // Test  SQW pin, D2 = Pullup on

  RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entree startAddr in NV-RAM address 0x08
  TimeIsSet = 0xffff;
  RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
  RTC.ctrl = 0x00;     // 0x00=disable SQW pin, 0x10=1Hz,
  // 0x11=4096Hz, 0x12=8192Hz, 0x13=32768Hz
  RTC.setCTRL();

  pinMode( Touche_PIN, INPUT );         //Défini A0 comme entrée
  digitalWrite( Touche_PIN, LOW );      //A0 en possition 0.

  u8g.setFont(u8g_font_6x12); //Font Afficheur
  // u8g.setFont(u8g_font_fur14); //Font Afficheur

  rad = ((2 * 3.1415926536) / 360);

  // Sortie synthétiseur toutes à zero.
  DDRB = B11111111; //Concerne la gestion portB (pin 8 à pin 13)
}
//////////////////////////////////////////////////////////////////////////////////

void Horloge()
{
  sensorValue = analogRead(sensorPin); // lecture de la touche
  val_key = int(sensorValue / 100);    // valeur entière de la touche / 10

  /// Affichage marche////
  if  (Select == 0)
  {
    RTC.getTime();
    Heure = RTC.hour;
    Minute = RTC.minute;
    Seconde = RTC.second;
    Jour = RTC.day;
    Mois = RTC.month;
    Annee = RTC.year;

    //FONT
    u8g.setFont(u8g_font_timB14);

    if (Heure < 10) {
      u8g.drawStr( 60, 26, "0");
      u8g.setPrintPos(69, 26); //Heure
      u8g.print(Heure);
    }
    else
    { u8g.setPrintPos(61, 25); //Heure
      u8g.print(Heure);
    }

    u8g.drawStr( 78, 25, ":");

    if (Minute < 10) {
      u8g.drawStr( 84, 25, "0");
      u8g.setPrintPos( 94, 25);//Minute
      u8g.print(Minute);
    }
    else
    { u8g.setPrintPos( 85, 25);//Minute
      u8g.print(Minute);
    }

    u8g.drawStr( 102, 25, ":");

    if (Seconde < 10) {
      u8g.drawStr( 108, 25, "0");
      u8g.setPrintPos( 117, 25);//Seconde
      u8g.print(Seconde);
    }
    else
    { u8g.setPrintPos(108, 25);//Seconde
      u8g.print(Seconde);
    }


    u8g.setFont(u8g_font_5x7); //Font Afficheur

    //////////////////////////////////////////////////////////////////////////////
    switch (RTC.dow)
    {
      case 1:
        u8g.drawStr( 73, 47, " Lundi  ");
        break;
      case 2:
        u8g.drawStr( 73, 47, " Mardi  ");
        break;
      case 3:
        u8g.drawStr( 73, 47, "Mercredi");
        break;
      case 4:
        u8g.drawStr( 73, 47, " Jeudi  ");
        break;
      case 5:
        u8g.drawStr( 73, 47, "Vendredi");
        break;
      case 6:
        u8g.drawStr( 73, 47, " Samedi ");
        break;
      case 0:
        u8g.drawStr( 73, 47, "Dimanche");
        break;
    }

    //////////////////////////////////////////////////////
    if (Jour < 10) {
      u8g.drawStr( 57, 57, "0");
      u8g.setPrintPos(62, 57); //Jour
      u8g.print(Jour);
    }
    else
    { u8g.setPrintPos(57, 57); //Jour
      u8g.print(Jour);
    }

    switch (RTC.month) {
      case 1:
        u8g.drawStr( 70, 57, "Janvier");
        break;
      case 2:
        u8g.drawStr( 70, 57, "fevrier");
        break;
      case 3:
        u8g.drawStr( 70, 57, "  mars");
        break;
      case 4:
        u8g.drawStr( 70, 57, " avril ");
        break;
      case 5:
        u8g.drawStr( 70, 57, "  mai  ");
        break;
      case 6:
        u8g.drawStr( 70, 57, " juin  ");
        break;
      case 7:
        u8g.drawStr( 70, 57, "Juillet");
        break;
      case 8:
        u8g.drawStr( 69, 57, "  aout  ");
        break;
      case 9:
        u8g.drawStr( 70, 57, " septe.");
        break;
      case 10:
        u8g.drawStr( 69, 57, "octobre");
        break;
      case 11:
        u8g.drawStr( 70, 57, "novemb.");
        break;
      case 12:
        u8g.drawStr( 70, 57, "decemb.");
        break;
    }
    u8g.setPrintPos(106, 57); //Année
    u8g.print(Annee);
  }
  ///////////////////////////////
  //Dessin horloge - Aiguilles///
  ///////////////////////////////
  angles = (Seconde * 6) - 90;
  anglem = (Minute * 6) - 90;
  angleh = ((Heure * 30) - 90) + ((anglem / 12) + 6);
  Serial.println (angleh);

  u8g.drawCircle(31, 32, 21);
  u8g.drawCircle(31, 32, 19);

  u8g.setFont(u8g_font_micro);
  u8g.drawStr( 56, 35, "3");
  u8g.drawStr( 30, 60, "6");
  u8g.drawStr( 3, 35, "9");
  u8g.drawStr( 28, 10, "12");

  u8g.drawStr( 40, 16, "."); //1
  u8g.drawStr( 47, 24, "."); //2
  u8g.drawStr( 50, 33, "."); //3
  u8g.drawStr( 47, 42, ".");  //4
  u8g.drawStr( 41, 50, ".");  //5
  u8g.drawStr( 31, 53, ".");  //6
  u8g.drawStr( 21, 50, ".");  //7
  u8g.drawStr( 14, 42, ".");  //8
  u8g.drawStr( 11, 33, ".");  //9
  u8g.drawStr( 14, 24, ".");  //10
  u8g.drawStr( 21, 16, ".");  //11
  u8g.drawStr( 31, 14, "."); //12

  xs = 31 + (cos(angles * rad) * 18);
  ys = 32 + (sin(angles * rad) * 18);
  u8g.drawLine(31, 32, xs, ys);


  xm = 31 + (cos(anglem * rad) * 16);
  ym = 32 + (sin(anglem * rad) * 16);
  u8g.drawLine(31, 32, xm, ym);
  u8g.drawLine(32, 31, xm, ym);


  xh = 31 + (cos(angleh * rad) * 10);
  yh = 32 + (sin(angleh * rad) * 10);
  u8g.drawLine(31, 32, xh, yh);
  u8g.drawLine(32, 31, xh, yh);


  ///////////////////////////////////////////////////////////////////////////////////////////
  //                                  R E G L A G E                                        //
  ///////////////////////////////////////////////////////////////////////////////////////////


  if ((Select > 0) and (Select < 8))
  {
    u8g.drawStr(80, 18, "REGLAGES");

    if (Jour < 10)  {
      u8g.drawStr( 73, 30, "0");
      u8g.setPrintPos(77, 30); //Jour
      u8g.print(Jour);
    }
    else
    { u8g.setPrintPos(73, 30); //jour
      u8g.print(Jour);
    }

    u8g.drawStr( 83, 30, ":");

    if (Mois < 10) {
      u8g.drawStr( 89, 30, "0");
      u8g.setPrintPos( 94, 30);//Mois
      u8g.print(Mois);
    }
    else
    { u8g.setPrintPos(89, 30); //Mois
      u8g.print(Mois);
    }

    u8g.drawStr( 100, 30, ":");

    u8g.setPrintPos( 105, 30);//Annee
    u8g.print(Annee);

    if (Heure < 10) {
      u8g.drawStr( 78, 40, "0");
      u8g.setPrintPos(82, 40); //Heure
      u8g.print(Heure);
    }
    else
    { u8g.setPrintPos(78, 40); //Heure
      u8g.print(Heure);
    }

    u8g.drawStr( 88, 40, ":");

    if (Minute < 10) {
      u8g.drawStr(93, 40, "0");
      u8g.setPrintPos( 98, 40);//Minute
      u8g.print(Minute);
    }
    else
    { u8g.setPrintPos( 93, 40);//Minute
      u8g.print(Minute);
    }

    u8g.drawStr( 105, 40, ":");

    if (Seconde < 10) {
      u8g.drawStr(110, 40, "0");
      u8g.setPrintPos( 115, 40);//Seconde
      u8g.print(Seconde);
    }
    else
    { u8g.setPrintPos( 110, 40);//Seconde
      u8g.print(Seconde);
    }
  }

  val_key = 0;                           // RAZ valeur de la touche
  sensorValue = analogRead(sensorPin);   // lecture de la touche
  val_key = int(sensorValue / 100);      // valeur entière de la touche / 100

  ////////////////////////////////////////////////////////
  /////////// Selection des reglages /////////////////////
  ////////////////////////////////////////////////////////

  switch (val_key)
  {
    delay (200);
    case 7:                              //  7: Valeur de la touche "Parole" à modifier selon pavé boutons  ////////////////////////////////////////////////////////////////////////
      Parlante();
      break;

    case 0 : //Select
      {
        Select = (Select + 1);
        delay (200);
      }
      break;
  }

  if (Select == 1) u8g.drawStr(70, 50, " Reglage jour");

  if (Select == 2) u8g.drawStr(70, 50, " Reglage mois");

  if (Select == 3) u8g.drawStr(65, 50, " Reglage annee");

  if (Select == 4) u8g.drawStr(70, 50, "Reglage heures");

  if (Select == 5) u8g.drawStr(70, 50, "Reglage minutes");

  if (Select == 6) u8g.drawStr(65, 50, "Reglage Secondes");

  if (Select == 7) u8g.drawStr(90 , 50, "TOP !");

  if (Select == 8) {
    (Select = 0);
    RTC.setRAM(0, (uint8_t *)&startAddr, sizeof(uint16_t));// Entrée startAddr dans NV-RAM address 0x08
    TimeIsSet = 0xffff;
    RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
    if (TimeIsSet != 0xaa55)
    {
      RTC.stopClock();
      RTC.fillByYMD(Annee, Mois, Jour);
      RTC.fillByHMS(Heure, Minute, Seconde);

      RTC.setTime();
      TimeIsSet = 0xaa55;
      RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
      RTC.startClock();
    }
    else
    {
      RTC.getTime();
    }
  }

  switch (val_key)
  {
    case 1: //Down    ///     1: Valeur de la touche "Down" à modifier selon pavé boutons  /////////////////////////////////////////////////////////////////////////////
      {
        delay (200);
        if (Select == 1) {
          Jour = (Jour - 1);
        }
        if (Jour < 1) {
          (Jour = 31);
        }
        if (Select == 2) {
          Mois = (Mois - 1);
        }
        if (Mois < 1) {
          (Mois = 12);
        }
        if (Select == 3) {
          Annee = (Annee - 1);
        }

        if (Select == 4) {
          Heure = (Heure - 1);
        }
        if (Heure < 1) {
          (Heure = 23);
        }
        if (Select == 5) {
          Minute = (Minute - 1);
        }
        if (Minute < 1) {
          (Minute = 59);
        }
        if (Select == 6) {
          Seconde = (Seconde - 1);
        }
        if (Seconde < 1) {
          (Seconde = 59);
        }
      }
      break;

    case 3: //UP      ////3: Valeur de la touche "Up" à modifier selon pavé boutons    ////////////////////////////////////////////////////////////////////
      {
        delay (200);
        if (Select == 1) {
          Jour = (Jour + 1);
        }
        if (Jour > 31) {
          (Jour = 1);
        }
        if (Select == 2) {
          Mois = (Mois + 1);
        }
        if (Mois > 12) {
          (Mois = 1);
        }
        if (Select == 3) {
          Annee = (Annee + 1);
        }

        if (Select == 4) {
          Heure = (Heure + 1);
        }
        if (Heure > 23) {
          (Heure = 0);
        }
        if (Select == 5) {
          Minute = (Minute + 1);
        }
        if (Minute > 59 ) {
          (Minute = 0);
        }
        if (Select == 6) {
          Seconde = (Seconde + 1);
        }
        if (Seconde > 59) {
          (Seconde = 0);
        }
      }
      break;
  }
}
////////////////////////////////////////////////
/////////////////////////////////////////////////

void Parlante()
{
  switch (Heure) {

    case 1:
      PORTB = B00011110; //1
      break;

    case 2:
      PORTB = B00011101; //2
      break;

    case 3:
      PORTB = B00011100; //3
      break;

    case 4:
      PORTB = B00011011; //4
      break;

    case 5:
      PORTB = B00011010; //5
      break;

    case 6:
      PORTB = B00011001; //6
      break;

    case 7:
      PORTB = B00011000; //7
      break;

    case 8:
      PORTB = B00010111; //8
      break;

    case 9:
      PORTB = B00010110; //9
      break;

    case 10:
      PORTB = B00010101; //10
      break;

    case 11:
      PORTB = B00010100; //11
      delay(200);
      break;

    case 12:
      PORTB = B00010011; //12       
      break;

    case 13:
      PORTB = B00010010; //13
      break;

    case 14:
      PORTB = B00010001; //14
      break;

    case 15:
      PORTB = B00010000; //15
      break;

    case 16:
      PORTB = B00001111; // 16
      break;

    case 17:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (200);
      PORTB = B00011000; //7
      break;

    case 18:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B00011111;
      delay (200);
      PORTB = B00010111; //8
      break;

    case 19:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (200);
      PORTB = B00010110; //9
      break;

    case 20:
      PORTB = B00001110; //20
     /* delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
     */ delay (300);
      break;

    case 21:
      PORTB = B00001110; //20
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (300);
      PORTB = B00000100; // té
      delay (130);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011110; //1
      break;

    case 22:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (300);
      PORTB = B00011101; //2

      break;

    case 23:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (300);
      PORTB = B00011100; //3
      break;

    case 0:
      PORTB = B00000011; //zero 
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      break;
  }

  delay (100);
  PORTB = B00000000;
  PORTB = B11111111;
  delay (300);

   
  if ((Heure == 0) ||(Heure == 1) || (Heure == 4)|| (Heure == 5) || (Heure == 9) || (Heure == 19)) { PORTB = B00001001;}//Heure}    
  else
  {if ((Heure == 7)||(Heure == 8) || (Heure == 17)|| (Heure == 18) || (Heure == 20)) { PORTB = B00000001;} //theure
  else  
 {PORTB = B00000010;}} //zheure
  
  
  
  delay (30);
  PORTB = B00000000;
  PORTB = B11111111;
  delay (400);
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  switch (Minute) {

    case 0:
      PORTB = B00000011; //zero
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (150);  
      break;
    
    case 1:
      PORTB = B00011110; //1
      break;

    case 2:
      PORTB = B00011101; //2
      break;

    case 3:
      PORTB = B00011100; //3
      break;

    case 4:
      PORTB = B00011011; //4
      break;

    case 5:
      PORTB = B00011010; //5
      break;

    case 6:
      PORTB = B00011001; //6
      break;

    case 7:
      PORTB = B00011000; //7
      break;

    case 8:
      PORTB = B00010111; //8
      break;

    case 9:
      PORTB = B00010110; //9
      break;

    case 10:
      PORTB = B00010101; //10
      delay (125);
      break;

    case 11:
      PORTB = B00010100; //11
      delay(200);
      break;

    case 12:
      PORTB = B00010011; //12
      break;

    case 13:
      PORTB = B00010010; //13
      break;

    case 14:
      PORTB = B00010001; //14
      break;

    case 15:
      PORTB = B00010000; //15
      break;

    case 16:
      PORTB = B00001111; // 16
      break;

    case 17:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011000; //7
      break;

    case 18:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B00011111;
      delay (125);
      PORTB = B00010111; //8
      break;

    case 19:
      PORTB = B00010101; //10
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00010110; //9
      break;

    case 20:
      PORTB = B00001110; //20
      delay (150);
      break;

    case 21:
      PORTB = B00001110; //20
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (200);
      PORTB = B00000100; // té
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011110; //1
      break;

    case 22:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011101; //2
      break;

    case 23:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011100; //3
      break;

    case 24:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011011; //4
      break;

    case 25:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011010; //5
      break;

    case 26:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011001; //6
      break;

    case 27:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011000; //7
      break;

    case 28:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00010111; //8
      break;

    case 29:
      PORTB = B00001110; //20
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00010110; //29
      break;
 
    case 30:
      PORTB = B00001101; //30
      delay (250);
      break;

    case 31:
      PORTB = B00001101; //30
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00000100; // té
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011110; //1
      break;

    case 32:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011101; //2
      break;

    case 33:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011100; //3
      break;

    case 34:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011011; //4
      break;

    case 35:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011010; //5
      break;

    case 36:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011001; //6
      break;

    case 37:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00011000; //7
      break;

    case 38:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00010111; //8
      break;

    case 39:
      PORTB = B00001101; //30
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (250);
      PORTB = B00010110; //9
      break;

    case 40:
      PORTB = B00001100; //40
      delay (200);
      break;

    case 41:
      PORTB = B00001100; //40
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (300);
      PORTB = B00000100; // té
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011110; //1
      break;

    case 42:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011101; //2
      break;

    case 43:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011100; //3
      break;

    case 44:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011011; //4
      break;

    case 45:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011010; //5
      break;

    case 46:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011001; //6
      break;

    case 47:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00011000; //7
      break;

    case 48:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00010111; //8
      break;

    case 49:
      PORTB = B00001100; //40
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (125);
      PORTB = B00010110; //9
      break;

    case 50:
      PORTB = B00001011; //50
      delay (400);
      break;

    case 51:
      PORTB = B00001011; //50
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00000100; // té
      delay (30);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (100);
      PORTB = B00011110; //1
      break;

    case 52:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00011101; //2
      break;

    case 53:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (500);
      PORTB = B00011100; //3
      break;

    case 54:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00011011; //4
      break;

    case 55:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00011010; //5
      break;

    case 56:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00011001; //6
      break;

    case 57:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00011000; //7
      break;

    case 58:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00010111; //8
      break;

    case 59:
      PORTB = B00001011; //50
      delay (25);
      PORTB = B00000000;
      PORTB = B11111111;
      delay (400);
      PORTB = B00010110; //9
      break;

  }
  delay (250);
  PORTB = B00000000;
  PORTB = B11111111;
  delay (100);

  PORTB = B00000110; //minute
  delay (350);
  PORTB = B00000000;
  PORTB = B11111111;
}

void loop()
{
  u8g.firstPage();
  do
    Horloge();
  while ( u8g.nextPage());


}

